=== debian/changelog ===
racket (7.2+dfsg1-2ubuntu3) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 15 Jan 2020 18:24:43 +0100

racket (7.2+dfsg1-2ubuntu2) eoan; urgency=medium

  * Really set cflags in a way that cdbs will see them.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 27 Aug 2019 17:55:23 -0700

racket (7.2+dfsg1-2ubuntu1) eoan; urgency=medium

  * Ensure building with -O2 to work around a misbuild on ppc64el which
    defaults to -O3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 27 Aug 2019 17:11:35 -0700

racket (7.2+dfsg1-2) unstable; urgency=medium

  * Upload to unstable.

 -- David Bremner <bremner@debian.org>  Tue, 19 Feb 2019 17:11:01 -0400

racket (7.2+dfsg1-1) experimental; urgency=medium

  * New upstream bugfix release.
  * Bug fix: "Install Package doesn't work in DrRacket", thanks to
    Mike Manilone (Closes: #922444).

 -- David Bremner <bremner@debian.org>  Sat, 16 Feb 2019 20:59:49 -0400
