=== debian/changelog ===
racket (7.8+dfsg1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Ensure building with -O2 to work around a misbuild on ppc64el which
    defaults to -O3.
    - Build with gcc-9 to work around failure to build on s390x

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 27 Aug 2020 10:21:12 +0100

racket (7.8+dfsg1-1) unstable; urgency=medium

  * Update to new upstream version 7.8+dfsg1.

 -- David Bremner <bremner@debian.org>  Mon, 03 Aug 2020 16:48:09 -0300

racket (7.6+dfsg1-3) unstable; urgency=medium

  * Restore upstream commit 17bc6262938f, try a different armhf gmp fix
    from Paulo Matos (upstream commit 392dc33ce)

 -- David Bremner <bremner@debian.org>  Wed, 22 Apr 2020 11:27:27 -0300

racket (7.6+dfsg1-2) unstable; urgency=medium

  * Revert upstream commit 17bc6262938f (Closes: #948789). This might or
    might not re-introduce numerical problems on armhf
    (https://github.com/racket/racket/issues/2773). Reports welcome.
  * Switch to debrebase and (hopefully dgit) for maintenence.

 -- David Bremner <bremner@debian.org>  Wed, 15 Apr 2020 18:56:52 -0300

racket (7.6+dfsg1-1) unstable; urgency=medium

  * New upstream bugfix release
  * Patch from Asumu to enable useprefix (needed for 7.6)

 -- David Bremner <bremner@debian.org>  Fri, 13 Mar 2020 20:58:28 -0300

racket (7.5+dfsg2-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Drop openssl patch, upstream now recognizes 1.0.2

 -- David Bremner <bremner@debian.org>  Mon, 30 Dec 2019 17:47:51 -0400
