=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  libfreetype6-dev, libjpeg-dev, libpango1.0-dev, libpng-dev, libssl-dev,
  libxaw7-dev, xbitmaps, libxft-dev, libgl1-mesa-dev | libgl-dev,
  libglu1-mesa-dev | libglu-dev, libx11-dev, libxrender-dev, libcairo2-dev,
- sqlite3
+ sqlite3, gcc-9, g++-9
 Vcs-Git: https://salsa.debian.org/bremner/racket
 Vcs-Browser: https://salsa.debian.org/bremner/racket
 Homepage: https://www.racket-lang.org/
