=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+export CC=gcc-9
+export CXX=g++-9
 
 DEB_CFLAGS_MAINT_APPEND := -O2
 include /usr/share/cdbs/1/rules/debhelper.mk
@@ -25,6 +28,10 @@
 ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
     DEB_CONFIGURE_EXTRA_FLAGS += --enable-noopt
 endif
+
+# Explicitly enable useprefix for unix-style build (needed for v7.6)
+# See https://github.com/racket/racket/issues/3046
+DEB_CONFIGURE_EXTRA_FLAGS += --enable-useprefix
 
 # Support for generating ".orig.tar.gz" from git
